import { PrefetchCacheEntryStatus, type AppRouterState, type PrefetchCacheEntry } from './router-reducer-types';
/**
 * Creates a cache key for the router prefetch cache
 *
 * @param url - The URL being navigated to
 * @param nextUrl - an internal URL, primarily used for handling rewrites. Defaults to '/'.
 * @return The generated prefetch cache key.
 */
export declare function createPrefetchCacheKey(url: URL, nextUrl: string | null): string;
export declare function prunePrefetchCache(prefetchCache: AppRouterState['prefetchCache']): void;
export declare function getPrefetchEntryCacheStatus({ kind, prefetchTime, lastUsedTime, }: PrefetchCacheEntry): PrefetchCacheEntryStatus;
